<template>
  <div class="box-main">
    <MomTable
      ref="MomTable"
      row-key="id"
      :row-selection="rowSelection"
      :columns="tableColumns"
      :data-source="tableData"
      :query-param="queryForm"
      :query-param-item="queryFormItem"
      :total="total"
      :page.sync="page"
      :action-buttons="actionButtons"
      :show-enable-flag="true"
      @beforeSearch="beforeSearch"
      @edit="handleEdit"
      @delete="handleDelete"
      @search="searchPageData"
      @enable="
        (record) =>
          handleStatus(
            { status: 'Y', id: record.id },
            'ENABLED',
            'ENABLED_DATA_INFO',
            'ENABLE_SUCCESS'
          )
      "
      @disable="
        (record) =>
          handleStatus(
            { status: 'N', id: record.id },
            'DISABLED',
            'DISABLED_DATA_INFO',
            'DISABLE_SUCCESS'
          )
      "
    >
      <div slot="toolbar" class="button-top-table">
        <a-button
          v-if="hasAuth('ENTERPRISE_WECHAT_SETTING:ADD')"
          type="primary"
          @click="handleAdd"
        >
          <a-icon type="plus" /> {{ $t("ADD") }}
        </a-button>
        <a-button
          v-if="hasAuth('ENTERPRISE_WECHAT_SETTING:BATCH_DELETE')"
          type="danger"
          icon="delete"
          @click="handDelete"
        >
          {{ $t("BATCH_DELETE") }}
        </a-button>
      </div>
      <template slot="enableFlag" slot-scope="text">
        <span :class="text === 'Y' ? 'text-success' : 'text-error'">
          {{ formatData(statusList, text) }}
        </span>
      </template>
    </MomTable>
    <MegaDrawer
      :visible="drawerVisible"
      :title="form.id ? $t('EDIT') : $t('ADD')"
      width="520"
      @close="handleClose"
    >
      <template slot="main">
        <a-form-model
          ref="addForm"
          layout="vertical"
          :model="form"
          :rules="rules"
        >
          <a-row>
            <a-col :span="24">
              <a-form-model-item :label="$t('CONFIG_CODE')" prop="accountCode">
                <a-input
                  v-model="form.accountCode"
                  :disabled="form.id !== null && form.id !== ''"
                />
              </a-form-model-item>
            </a-col>
            <a-col :span="24">
              <a-form-model-item :label="$t('CONFIG_NAME')" prop="accountName">
                <a-input v-model="form.accountName" />
              </a-form-model-item>
            </a-col>
            <a-col :span="24">
              <a-form-model-item :label="$t('APP_KEY')" prop="appKey">
                <a-input v-model="form.appKey" />
              </a-form-model-item>
            </a-col>
            <a-col :span="24">
              <a-form-model-item :label="$t('APP_SECRET')" prop="appSecret">
                <a-input v-model="form.appSecret" />
              </a-form-model-item>
            </a-col>
            <a-col :span="24">
              <a-form-model-item :label="$t('AGENT_ID')" prop="agentId">
                <a-input v-model="form.agentId" />
              </a-form-model-item>
            </a-col>
          </a-row>
        </a-form-model>
      </template>
      <footer slot="footer">
        <a-button type="primary" @click="handleSave()">
          <Icon type="icon-cur-save_1" :size="18" />{{ $t("SAVE") }}
        </a-button>
        <a-button @click="handleClose">
          <Icon type="icon-dir-f-rollback" :size="18" />{{ $t("CANCEL") }}
        </a-button>
      </footer>
    </MegaDrawer>
  </div>
</template>
<script>
import { Drawer as MegaDrawer, Icon } from "@mega-design/ui-vue";
import ApiConstant from "@/api/ApiConstant";

export default {
  components: {
    MegaDrawer,
    Icon,
  },
  data() {
    return {
      title: "", // 弹框标题
      drawerVisible: false, // 新增修改的弹框
      // 查询sort
      tableData: [], // 表格数据
      page: 1, // 分页第几页
      total: 0, // 数据表格总条数
      form: {
        id: "",
        accountCode: "",
        accountName: "",
        appKey: "",
        appSecret: "",
        agentId: "",
      },
      rules: {
        accountCode: [
          {
            max: 32,
            required: false,
            message: this.$t("PLACEENTER") + 32 + this.$t("LENGTH_TIP"),
            trigger: "blur",
          },
        ],
        accountName: [
          {
            max: 64,
            required: true,
            message: this.$t("PLACEENTER") + 64 + this.$t("LENGTH_TIP"),
            trigger: "blur",
          },
        ],
        appKey: [
          {
            max: 64,
            required: true,
            message: this.$t("PLACEENTER") + 64 + this.$t("LENGTH_TIP"),
            trigger: "blur",
          },
        ],
        appSecret: [
          {
            max: 64,
            required: true,
            message: this.$t("PLACEENTER") + 64 + this.$t("LENGTH_TIP"),
            trigger: "blur",
          },
        ],
        agentId: [
          {
            max: 64,
            required: true,
            message: this.$t("PLACEENTER") + 64 + this.$t("LENGTH_TIP"),
            trigger: "blur",
          },
        ],
      },
      statusList: [], // 状态列表
      // 查询的表单的配置项
      queryForm: {
        accountCode: "",
        accountName: "",
      },
      actionButtons: [
        this.hasAuth("ENTERPRISE_WECHAT_SETTING:EDIT") && "edit",
        this.hasAuth("ENTERPRISE_WECHAT_SETTING:DELETE") && "delete",
      ],
      selectedRowKeys: [],
    };
  },
  computed: {
    rowSelection() {
      return {
        selectedRowKeys: this.selectedRowKeys,
        onChange: (selectedRowKeys, selectedRows) => {
          this.selectedRowKeys = selectedRowKeys;
        },
      };
    },
    queryFormItem() {
      return this.$observable("queryFormItem", {
        accountCode: {
          label: () => this.$t("CONFIG_CODE"),
        },
        accountName: {
          label: () => this.$t("CONFIG_NAME"),
        },
      });
    },
    tableColumns() {
      return [
        {
          dataIndex: "accountCode",
          title: this.$t("CONFIG_CODE"),
          ellipsis: true,
          sorter: false,
        },
        {
          dataIndex: "accountName",
          ellipsis: true,
          title: this.$t("CONFIG_NAME"),
          width: 210,
        },
        {
          dataIndex: "appKey",
          title: () => this.$t("APP_KEY"),
          ellipsis: true,
          width: 180,
        },
        {
          dataIndex: "agentId",
          title: () => this.$t("AGENT_ID"),
          ellipsis: true,
          width: 180,
        },
        {
          dataIndex: "enableFlag",
          sorter: false,
          title: () => this.$t("STATUS"),
          scopedSlots: { customRender: "enableFlag" },
          width: 120,
        },
        // 更新人员
        {
          dataIndex: "updateBy",
          sorter: false,
          title: this.$t("UPDATE_BY"),
          width: 210,
        },
        // 更新时间
        {
          dataIndex: "updateTime",
          sorter: false,
          title: this.$t("UPDATE_TIME"),
          width: 210,
        },
      ];
    },
  },
  methods: {
    beforeSearch() {
      return Promise.all([
        this.getDictByCode(`DIC:COMMON:ENABLE_FLAG`), // 启用状态
      ]).then(([enableStatusRes]) => {
        this.statusList = enableStatusRes.data.data;
      });
    },
    formatData(data, curItem) {
      const result = data.find((item) => item.value === curItem);
      return result ? result.label : "";
    },
    searchPageData(params) {
      this.$axios
        .get(`${ApiConstant.PREFIX_CORE}/api/dingtalk/account/search`, {
          params,
        })
        .then((res) => {
          this.tableData = res.data.data.records;
          this.total = parseFloat(res.data.data.total);
        });
    },
    // 新增按钮的点击
    handleAdd() {
      this.$set(this, "form", {
        id: null,
        accountCode: "",
        accountName: "",
        appKey: "",
        appSecret: "",
        agentId: "",
      });
      this.drawerVisible = true;
    },
    // 编辑按钮点击
    handleEdit(row) {
      this.$axios
        .get(
          `${ApiConstant.PREFIX_CORE}/api/dingtalk/account/get-by-id/${row.id}`
        )
        .then((res) => {
          this.form = { ...res?.data?.data };
          this.drawerVisible = true;
        });
    },
    // 监听点击保存事件
    handleSave() {
      this.$refs.addForm.validate((valid) => {
        if (valid) {
          const req = {
            ...this.form,
          };
          if (!this.form?.id) {
            this.$axios
              .post(`${ApiConstant.PREFIX_CORE}/api/dingtalk/account`, req)
              .then((res) => {
                this.$message.success(this.$t("ADD_SUCCESS"));
                this.$refs.MomTable?.query();
                this.drawerVisible = false;
              });
          } else {
            this.$axios
              .put(`${ApiConstant.PREFIX_CORE}/api/dingtalk/account`, req)
              .then((res) => {
                this.$message.success(this.$t("EDIT_SUCCESS"));
                this.$refs.MomTable?.query();
                this.drawerVisible = false;
              });
          }
        }
      });
    },
    handDelete() {
      if (this.selectedRowKeys.length > 0) {
        this.$confirm({
          title: this.$t("DELETE"),
          content: this.$t("DELETE_INFO"),
          okType: "warning",
          okText: this.$t("CONFIRM"),
          cancelText: this.$t("CANCEL"),
          centered: false,
          icon: "close-circle",
          onOk: () => {
            this.$axios
              .delete(
                `${ApiConstant.PREFIX_CORE}/api/dingtalk/account/batch-delete`,
                {
                  params: {
                    ids: this.selectedRowKeys.join(","),
                  },
                }
              )
              .then((res) => {
                this.selectedRowKeys = [];
                this.$message.success(this.$t("SUBMITTED_FOR_DELETION"));
                this.$refs.MomTable?.query();
              });
          },
        });
      } else {
        this.$message.error(this.$t("SELECT_ONE_DATA"));
      }
    },
    // 点击表格行内的删除
    handleDelete(row) {
      this.$confirm({
        title: this.$t("DELETE"),
        content: this.$t("DELETE_INFO"),
        okType: "warning",
        okText: this.$t("CONFIRM"),
        cancelText: this.$t("CANCEL"),
        centered: false,
        icon: "close-circle",
        onOk: () => {
          this.$axios
            .delete(`${ApiConstant.PREFIX_CORE}/api/dingtalk/account/${row.id}`)
            .then((res) => {
              this.$message.success(this.$t("SUBMITTED_FOR_DELETION"));
              this.$refs.MomTable?.query();
            });
        },
      });
    },
    // 启用、禁用
    handleStatus(record, titleText, contentText, tips) {
      this.$confirm({
        title: this.$t(titleText),
        content: this.$t(contentText),
        okText: this.$t("CONFIRM"),
        cancelText: this.$t("CANCEL"),
        centered: false,
        icon: "exclamation-circle",
        onOk: () => {
          const { id, status } = record;
          this.$axios
            .put(
              `${ApiConstant.PREFIX_CORE}/api/dingtalk/account/enable/${id}/${status}`
            )
            .then((res) => {
              this.$message.success(this.$t(tips));
              this.$refs.MomTable?.query();
            });
        },
      });
    },
    // 关闭弹框
    handleClose() {
      this.$refs.addForm.clearValidate();
      this.drawerVisible = false;
    },
  },
};
</script>
